// package: models.proto.cofd.api
// file: cofd_api.proto

import * as jspb from "google-protobuf";
import * as cofd_pb from "./cofd_pb";

export class CharacterIdentifier extends jspb.Message {
  getOwner(): string;
  setOwner(value: string): void;

  getId(): number;
  setId(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CharacterIdentifier.AsObject;
  static toObject(includeInstance: boolean, msg: CharacterIdentifier): CharacterIdentifier.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: CharacterIdentifier, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CharacterIdentifier;
  static deserializeBinaryFromReader(message: CharacterIdentifier, reader: jspb.BinaryReader): CharacterIdentifier;
}

export namespace CharacterIdentifier {
  export type AsObject = {
    owner: string,
    id: number,
  }
}

export class UpdateBasicInfoRequest extends jspb.Message {
  hasCharacter(): boolean;
  clearCharacter(): void;
  getCharacter(): CharacterIdentifier | undefined;
  setCharacter(value?: CharacterIdentifier): void;

  getName(): string;
  setName(value: string): void;

  getGender(): string;
  setGender(value: string): void;

  getConcept(): string;
  setConcept(value: string): void;

  getChronicle(): string;
  setChronicle(value: string): void;

  getAge(): number;
  setAge(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateBasicInfoRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateBasicInfoRequest): UpdateBasicInfoRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateBasicInfoRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateBasicInfoRequest;
  static deserializeBinaryFromReader(message: UpdateBasicInfoRequest, reader: jspb.BinaryReader): UpdateBasicInfoRequest;
}

export namespace UpdateBasicInfoRequest {
  export type AsObject = {
    character?: CharacterIdentifier.AsObject,
    name: string,
    gender: string,
    concept: string,
    chronicle: string,
    age: number,
  }
}

export class ApiResult extends jspb.Message {
  getSuccess(): boolean;
  setSuccess(value: boolean): void;

  getError(): string;
  setError(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ApiResult.AsObject;
  static toObject(includeInstance: boolean, msg: ApiResult): ApiResult.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ApiResult, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ApiResult;
  static deserializeBinaryFromReader(message: ApiResult, reader: jspb.BinaryReader): ApiResult;
}

export namespace ApiResult {
  export type AsObject = {
    success: boolean,
    error: string,
  }
}

export class UpdateAttributeRequest extends jspb.Message {
  hasCharacter(): boolean;
  clearCharacter(): void;
  getCharacter(): CharacterIdentifier | undefined;
  setCharacter(value?: CharacterIdentifier): void;

  getAttributeName(): string;
  setAttributeName(value: string): void;

  getAttributeValue(): number;
  setAttributeValue(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateAttributeRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateAttributeRequest): UpdateAttributeRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateAttributeRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateAttributeRequest;
  static deserializeBinaryFromReader(message: UpdateAttributeRequest, reader: jspb.BinaryReader): UpdateAttributeRequest;
}

export namespace UpdateAttributeRequest {
  export type AsObject = {
    character?: CharacterIdentifier.AsObject,
    attributeName: string,
    attributeValue: number,
  }
}

export class UpdateSkillRequest extends jspb.Message {
  hasCharacter(): boolean;
  clearCharacter(): void;
  getCharacter(): CharacterIdentifier | undefined;
  setCharacter(value?: CharacterIdentifier): void;

  hasSkill(): boolean;
  clearSkill(): void;
  getSkill(): cofd_pb.CofdSheet.Skill | undefined;
  setSkill(value?: cofd_pb.CofdSheet.Skill): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateSkillRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateSkillRequest): UpdateSkillRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateSkillRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateSkillRequest;
  static deserializeBinaryFromReader(message: UpdateSkillRequest, reader: jspb.BinaryReader): UpdateSkillRequest;
}

export namespace UpdateSkillRequest {
  export type AsObject = {
    character?: CharacterIdentifier.AsObject,
    skill?: cofd_pb.CofdSheet.Skill.AsObject,
  }
}

export class UpdateSkillValueRequest extends jspb.Message {
  hasCharacter(): boolean;
  clearCharacter(): void;
  getCharacter(): CharacterIdentifier | undefined;
  setCharacter(value?: CharacterIdentifier): void;

  getSkillName(): string;
  setSkillName(value: string): void;

  getSkillValue(): number;
  setSkillValue(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateSkillValueRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateSkillValueRequest): UpdateSkillValueRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateSkillValueRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateSkillValueRequest;
  static deserializeBinaryFromReader(message: UpdateSkillValueRequest, reader: jspb.BinaryReader): UpdateSkillValueRequest;
}

export namespace UpdateSkillValueRequest {
  export type AsObject = {
    character?: CharacterIdentifier.AsObject,
    skillName: string,
    skillValue: number,
  }
}

export class UpdateSkillSpecializationsRequest extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  clearSpecializationsList(): void;
  getSpecializationsList(): Array<string>;
  setSpecializationsList(value: Array<string>): void;
  addSpecializations(value: string, index?: number): string;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateSkillSpecializationsRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateSkillSpecializationsRequest): UpdateSkillSpecializationsRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateSkillSpecializationsRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateSkillSpecializationsRequest;
  static deserializeBinaryFromReader(message: UpdateSkillSpecializationsRequest, reader: jspb.BinaryReader): UpdateSkillSpecializationsRequest;
}

export namespace UpdateSkillSpecializationsRequest {
  export type AsObject = {
    name: string,
    specializationsList: Array<string>,
  }
}

export class AddConditionRequest extends jspb.Message {
  getCharacterUsername(): string;
  setCharacterUsername(value: string): void;

  getCharacterId(): number;
  setCharacterId(value: number): void;

  getConditionName(): string;
  setConditionName(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AddConditionRequest.AsObject;
  static toObject(includeInstance: boolean, msg: AddConditionRequest): AddConditionRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AddConditionRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AddConditionRequest;
  static deserializeBinaryFromReader(message: AddConditionRequest, reader: jspb.BinaryReader): AddConditionRequest;
}

export namespace AddConditionRequest {
  export type AsObject = {
    characterUsername: string,
    characterId: number,
    conditionName: string,
  }
}

export class RemoveConditionRequest extends jspb.Message {
  getCharacterUsername(): string;
  setCharacterUsername(value: string): void;

  getCharacterId(): number;
  setCharacterId(value: number): void;

  getConditionName(): string;
  setConditionName(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): RemoveConditionRequest.AsObject;
  static toObject(includeInstance: boolean, msg: RemoveConditionRequest): RemoveConditionRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: RemoveConditionRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): RemoveConditionRequest;
  static deserializeBinaryFromReader(message: RemoveConditionRequest, reader: jspb.BinaryReader): RemoveConditionRequest;
}

export namespace RemoveConditionRequest {
  export type AsObject = {
    characterUsername: string,
    characterId: number,
    conditionName: string,
  }
}

